UAWOWQuestGossip = UAWOWQuest:New("UAWOWQuestGossip")

UAWOWQuestGossip.QUEST_DATA_INFO_TEMPLATE = "QuestData: |cffffffff%s|r"

function UAWOWQuestGossip:OnInitialize()
    local obj = _G[self.base .. "TitleText"]
    obj:SetText("UAWOW ("  .. UAWOW.version .. ")")
    obj = _G[self.base .. "DataFrameText"]
    obj:SetFormattedText(self.QUEST_DATA_INFO_TEMPLATE, "unknown")

    self:Initialize()
    self.ScrollFrame = _G[self.Frame:GetName() .. "ScrollFrame"]

    self.QuestID =  _G[self.Frame:GetName() .. "QuestIdText"]
    self.QuestID:SetPoint("TOPLEFT", 0, -3)

    QuestFrameGreetingPanel:HookScript("OnShow", function()
        UAWOWQuestGossip.Frame:Hide()
    end)
    QuestFrameDetailPanel:HookScript("OnShow", function()
        UAWOWQuestGossip:QuestInfo(QUEST_DETAIL)
    end)
    QuestFrameProgressPanel:HookScript("OnShow", function()
        UAWOWQuestGossip.Frame:Hide()
    end)
    QuestFrameRewardPanel:HookScript("OnShow", function()
        UAWOWQuestGossip:QuestInfo(QUEST_COMPLETE)
    end)
end

function UAWOWQuestGossip:OnEnable()
    UAWOW:DebugLog("UAWOWQuestGossip: OnEnable.");

    local obj = _G[self.base .. "DataFrameText"]
    obj:SetFormattedText(self.QUEST_DATA_INFO_TEMPLATE, UAWOW.version)
end

function UAWOWQuestGossip:OnDisable()
    UAWOW:DebugLog("UAWOWQuestGossip: OnDisable.");
end

function UAWOWQuestGossip:QuestInfo(event)
    if not UAWOW.db.profile.quest.gossip then
        self.Frame:Hide()
        return
    end

    UAWOW:DebugLog("UAWOWQuestGossip:QuestInfo")

    self:Clear()

    local index = self:GetID(event)

    if index.error or index.questID == 0 then
        self.Frame:Hide()
        return
    end

    if event == QUEST_DETAIL then
        self:ShowDetail(index.questID)
    elseif event == QUEST_COMPLETE then
        self:ShowComplete(index.questID)
    end

    if self.UAWOW_Quest_Version == "unknown" and IsAddOnLoaded("UAWOW_Quest") then
        self.UAWOW_Quest_Version = UAWOW.property.quest.version
        local obj = _G[self.base .. "DataFrameText"]
        obj:SetFormattedText(self.QUEST_DATA_INFO_TEMPLATE, self.UAWOW_Quest_Version)
    end

    if QuestNPCModel:IsShown() then
        local point, relativeTo, relativePoint, xOffset, yOffset = QuestNPCModel:GetPoint(1) 
        QuestNPCModel:SetPoint(point, self.Frame, relativePoint, 0, yOffset)
    end
end

function UAWOWQuestGossip:ShowDetail(questID)
    self:Show(questID, {
        { type = 1, empty = false, target = "title",       text = "" },
        { type = 2, empty = true,  target = "description", text = "" },
        { type = 1, empty = false, target = "",            text = UAWOW.L["Objectives"] },
        { type = 2, empty = true,  target = "objective",   text = "" },
        { type = 1, empty = false, target = "",            text = UAWOW.L["Translation"] },
        { type = 2, empty = true,  target = "translation", text = "" },
    })
end

function UAWOWQuestGossip:ShowComplete(questID)
    self:Show(questID, {
        { type = 1, empty = false, target = "title",       text = "" },
        { type = 2, empty = false, target = "completion",  text = "" },
        { type = 1, empty = false, target = "",            text = UAWOW.L["Translation"] },
        { type = 2, empty = true,  target = "translation", text = "" },
    })
end
